package com.ycwl.basic.service.mobile;

import com.ycwl.basic.model.mobile.goods.*;
import com.ycwl.basic.utils.ApiResponse;

import java.math.BigDecimal;
import java.util.List;

/**
 * @Author：longbinbin
 * @Date：2024/12/5 15:03
 */
public interface GoodsService {

    /**
     * 查询商品列表
     * @param query 查询条件
     * @return
     */
    ApiResponse<List<GoodsPageVO>> goodsList(GoodsReqQuery query);

    /**
     * 查询源素材商品列表
     * @param query
     * @return
     */
    ApiResponse<List<GoodsDetailVO>> sourceGoodsList(GoodsReqQuery query);

    /**
     * 查询订单应付价格
     * @param queryPriceData
     * @return
     */
    ApiResponse<BigDecimal> queryPrice(GoodsPriceQueryReq queryPriceData);

    /**
     * @param userId  商品（vlog）id
     * @param videoId
     * @return
     */
    ApiResponse<VideoGoodsDetailVO> videoGoodsDetail(Long userId, Long videoId);

    /**
     * 查询当前用户的成片合成任务状态
     * @param userId
     * @return
     */
    ApiResponse<VideoTaskStatusVO> getTaskStatusByFaceId(Long userId ,Long faceId);
    ApiResponse<VideoTaskStatusVO> getAllTaskStatus(Long userId);

    ApiResponse<VideoTaskStatusVO> getTemplateTaskStatus(Long userId, Long faceId, Long templateId);

    ApiResponse<VideoTaskStatusVO> getTaskStatusByScenicId(Long userId, Long scenicId);
}
